# README.md

# Mnemosyne

A memorization app designed for lists as opposed to traditional flashcards

Mnemosyne, named for the Greek goddess of memory, is an app designed to aid one in remembering lists of related information. This particular memorization scenario is underserved by more traditional flashcard/memorization apps such as Anki. For example, if one is learning German, one would eventually have to memorize a list of around 50 verbs that are the so called "dative verbs". One could try to make a really big singular flashcard, or attempt something like cloze deletion, but these are very clunky methods. With Mnemosyne, one can simply enter the list items one at a time and get feedback on which ones were missed. One could then focus on just those items that are commonly missed or continue trying to get a perfect score on the original list. 

For convenience one can import a csv file into the app to create lists, or just create them manually. The csv must have a header row with the columns "Title" and "Items". Separate each item in the items column by the separate delimiter "#@!". Within a csv file, can specify multiple lists, one in each row. One can also export lists to save elsewhere.

There is a feature that allows for placing related lists together in a collapsible group. One can nest these groups to near arbitrary depth. One creates a group by prefixing the group title to the list title, followed by "::". For example, to create a grouping of German lists, where one wants a list of nouns and a list of verbs, one would name the two lists German::Nouns and German::Verbs.


## Features
- Open Source
- Respects your privacy
- CSV importing

## Installation
```sh
[installation command]
```
Download and install from the releases page or install from F-Droid.

## Usage
```sh
[usage command]
```

## Contributing
See [CONTRIBUTING.md](CONTRIBUTING.md) for guidelines on contributing.

## License
Mnemosyne is licensed under the GPLv3. See [LICENSE](LICENSE) for more details.
